﻿Module Module_TextCommands

    ' ===============================================================================================================
    '  TEST COMMAND SLOT and WRITE RESPONSES 
    ' ===============================================================================================================
    Friend CommandSlotText As Int32 = 0
    Friend ResponseSlotText As Int32 = 1

    Friend Sub EnsureSafeValueToTextSlots()
        StringSlots.WriteString(CommandSlotText, "")
        StringSlots.WriteString(ResponseSlotText, "")
    End Sub

    Private PollCommandSlotSyncLock As Object = New Object
    Private TextCommand As String
    Private TextCommandLowerCase As String
    Private TextCommandParameters As String
    Private ResponseString As String
    Friend Sub PollTextCommandsSlot()
        SyncLock PollCommandSlotSyncLock
            If CommandSlotText >= 0 Then
                ResponseString = "OK"
                TextCommand = StringSlots.ReadString(CommandSlotText)
                If TextCommand <> "" Then
                    StringSlots.WriteString(ResponseSlotText, "WORKING")
                    ' ------------------------------------------------------------- remove spaces and comments
                    RemoveComments(TextCommand)
                    TextCommand = ReplaceMultipleSpacesAndTabAndTrim(TextCommand)
                    ' ------------------------------------------------------------- 
                    'TextCommandFirstWord = TextCommand.Replace(vbTab, " ").Split(" "c)(0)
                    TextCommandParameters = RemoveFirstWord(TextCommand)
                    ' ------------------------------------------------------------- prepare lower case
                    TextCommandLowerCase = TextCommand.ToLower
                    ' ------------------------------------------------------------- split line
                    Dim sa() As String = TextCommandLowerCase.Split(" "c)
                    If sa.Length = 0 Then Return
                    ' ------------------------------------------------------------- extract params
                    Dim n(9) As Double
                    If sa.Length < n.Length Then
                        For i As Int32 = 1 To n.Length - 1
                            If i < sa.Length Then
                                n(i) = CDbl(Val(sa(i)))
                            End If
                        Next
                    End If
                    ' ------------------------------------------------------------- COMMANDS
                    Select Case sa(0)
                        ' ----------------------------------------------------- Toolbar commands
                        Case "recognize"
                            Form1.Cmd_Recognize()
                        Case "validate"
                            Form1.cmd_Validate()
                        Case "errorbeep"
                            SetCheckButton(Form1.ToolStripButton_BeepOnErrors, sa(1))
                        Case "disconnect"
                            Form1.Cmd_DisconnectSelectedModule()
                        Case "calibrate"
                            SetCheckButton(Form1.btn_Calibrate, sa(1))
                            ' ------------------------------------------------- Master properties 
                        Case "loadconfig"
                            If Form1.GroupBox_ModuleProps.Enabled Then
                                Form1.cmb_ModuleNames.Text = sa(1)
                                Form1.Change_SelectedModule_Name(sa(1))
                            End If
                        Case "speed"
                            If Form1.GroupBox_ModuleProps.Enabled Then
                                Form1.txt_CommSpeed.NumericValue = CInt(n(1))
                            End If
                            ' ------------------------------------------------- Select Master and Pin
                        Case "selectmaster", "selectmodule"
                            SelectMaster(CInt(n(1)))
                        Case "selectpin"
                            SelectPin(sa(1))
                            ' ------------------------------------------------- Pin properties
                        Case "setpintype"
                            Form1.cmb_PinType_DropDown(Nothing, Nothing)
                            Form1.cmb_PinType_DropDownClosed(Nothing, Nothing)
                            SetComboByText(Form1.cmb_PinType, TextCommandParameters)
                            Form1.cmb_PinType_SelectionChangeCommitted(Nothing, Nothing)
                        Case "setslot"
                            SetNumericValueInteger(Form1.txt_Slot, CInt(n(1)))
                        Case "setmaxvalue"
                            SetNumericValueFloat(Form1.txt_MaxValue, n(1))
                        Case "setminvalue"
                            SetNumericValueFloat(Form1.txt_MinValue, n(1))
                        Case "setresponsespeedbutton"
                            SetCheckButton(Form1.Label_ResponseSpeed, sa(1))
                        Case "setresponsespeed"
                            SetNumericValueInteger(Form1.txt_ResponseSpeed, CInt(n(1)))
                            ' ------------------------------------------------- PWM and Servo properties 
                        Case "maxtime"
                            SetNumericValueInteger(Form1.txt_ServoMaxTime, CInt(n(1)))
                        Case "mintime"
                            SetNumericValueInteger(Form1.txt_ServoMinTime, CInt(n(1)))
                        Case "logarithmicresponse"
                            SetCheckBox(Form1.chk_LogResponse, sa(1))
                            ' ------------------------------------------------- Stepper properties
                        Case "maxspeed"
                            SetNumericValueFloat(Form1.txt_MaxSpeed, n(1))
                        Case "maxacc"
                            SetNumericValueFloat(Form1.txt_MaxAcc, n(1))
                        Case "stepspermm"
                            SetNumericValueFloat(Form1.txt_StepsPerMillim, n(1))
                            ' ------------------------------------------------- Touch properties (cap)
                        Case "minvariation"
                            SetNumericValueInteger(Form1.txt_MinVariation, CInt(n(1)))
                        Case "proportionalarea"
                            SetNumericValueInteger(Form1.txt_ProportionalArea, CInt(n(1)))
                            ' ------------------------------------------------- Freq. properties (counter/fastcounter/period/slowperiod)
                        Case "converttofrequency"
                            SetCheckBox(Form1.chk_ConvertToFrequency, sa(1))
                        Case "maxfreq"
                            SetNumericValueInteger(Form1.txt_MaxFreq, CInt(n(1)))
                        Case "minfreq"
                            SetNumericValueInteger(Form1.txt_MinFreq, CInt(n(1)))
                            ' ------------------------------------------------- Adc24 properties
                        Case "samplessec"
                            If Form1.GroupBox_Adc24Props.Visible Then
                                SetComboByText(Form1.cmb_Adc24Sps, TextCommandParameters)
                                Form1.cmb_Adc24Sps_SelectionChangeCommitted(Nothing, Nothing)
                            Else
                                SetError("Command not valid: " + TextCommand)
                            End If
                        Case "filter"
                            If Form1.GroupBox_Adc24Props.Visible Then
                                SetComboByText(Form1.cmb_Adc24Filter, TextCommandParameters)
                                Form1.cmb_Adc24Filter_SelectionChangeCommitted(Nothing, Nothing)
                            Else
                                SetError("Command not valid: " + TextCommand)
                            End If
                            ' ------------------------------------------------- Adc24 channel properties
                        Case "type"
                            SetComboByText(Form1.cmb_Adc24ChType, TextCommandParameters)
                            Form1.cmb_Adc24ChType_SelectionChangeCommitted(Nothing, Nothing)
                        Case "gain"
                            SetComboByText(Form1.cmb_Adc24ChGain, TextCommandParameters)
                            Form1.cmb_Adc24ChGain_SelectionChangeCommitted(Nothing, Nothing)
                        Case "biased"
                            SetCheckBox(Form1.chk_Adc24ChBiased, sa(1))
                            ' ------------------------------------------------- GET COMMANDS
                        Case "getmastername", "getmodulename"
                            If ResponseSlotText >= 0 Then
                                If Form1.GroupBox_ModuleProps.Enabled Then
                                    ResponseString = Form1.cmb_ModuleNames.Text
                                Else
                                    SetError("Command not valid: " + TextCommand)
                                End If
                            End If
                        Case "getfps"
                            If ResponseSlotText >= 0 Then
                                If Form1.GroupBox_ModuleProps.Visible Then
                                    ResponseString = Form1.lbl_RepeatFrequency.Text
                                Else
                                    SetError("Command not valid: " + TextCommand)
                                End If
                            End If
                        Case "getpintype"
                            If ResponseSlotText >= 0 Then
                                If Form1.GroupBox_PinProps.Visible Then
                                    ResponseString = Form1.cmb_PinType.Text
                                Else
                                    SetError("Command not valid: " + TextCommand)
                                End If
                            End If
                            ' ------------------------------------------------- Error
                        Case Else
                            SetError("Command not recognized: " + TextCommand)
                    End Select
                    ' --------------------------------------------------------- UPDATE RESPONSE
                    StringSlots.WriteString(CommandSlotText, "")
                    If ResponseSlotText >= 0 Then
                        StringSlots.WriteString(ResponseSlotText, ResponseString)
                    End If
                End If
            End If
        End SyncLock
    End Sub

    Private Sub SetError(ByVal err As String)
        ResponseString = err
        Console.Beep(660, 50)
        Console.Beep(440, 50)
        Console.Beep(220, 150)
    End Sub

    Private Sub SelectMaster(ByVal index As Int32)
        If Form1.GroupBox_ModuleProps.Enabled Then
            Dim lv As ListView = Form1.MyListView1
            For i As Int32 = 0 To lv.Items.Count - 1
                Dim m As Module_InOut = FindModuleByListLine(i)
                If m IsNot Nothing AndAlso m.ModuleId = index - 1 Then
                    lv.Items(i).Selected = True
                    lv.EnsureVisible(i)
                    Return
                End If
            Next
        End If
        SetError("Command not valid: " + TextCommand)
    End Sub

    Private Sub SelectPin(ByVal PinName As String)
        If Form1.GroupBox_ModuleProps.Enabled Then
            Dim lv As ListView = Form1.MyListView1
            Dim i As Int32
            For i = lv.SelectedIndices(0) To 0 Step -1
                If lv.Items(i).SubItems(0).Text = "Module" Then Exit For
            Next
            For i = i + 1 To lv.Items.Count - 1
                If lv.Items(i).SubItems(0).Text = "Module" Then Exit For
                Dim p As Pin = FindPinByListLine(i)
                If p IsNot Nothing AndAlso p.PinName = PinName Then
                    lv.Items(i).Selected = True
                    lv.EnsureVisible(i)
                    Return
                End If
            Next
        End If
        SetError("Command not valid: " + TextCommand)
    End Sub

    Private Sub SetCheckButton(ByVal btn As ToolStripButton, ByVal check As String)
        If btn.Enabled And btn.Visible Then
            btn.Checked = check <> "off" And check <> "0"
        Else
            SetError("Option not enabled: " + TextCommand)
        End If
    End Sub

    Private Sub SetCheckButton(ByVal btn As MyButton, ByVal check As String)
        If btn.Enabled And btn.Visible Then
            btn.Checked = check <> "off" And check <> "0"
        Else
            SetError("Option not enabled: " + TextCommand)
        End If
    End Sub

    Private Sub SetCheckBox(ByVal chk As CheckBox, ByVal check As String)
        If chk.Enabled And chk.Visible Then
            chk.Checked = check <> "off" And check <> "0"
        Else
            SetError("Option not enabled: " + TextCommand)
        End If
    End Sub

    Private Sub SetNumericValueInteger(ByVal txt As MyTextBox, ByVal value As Int32)
        If txt.Enabled And txt.Visible Then
            txt.NumericValueInteger = value
            If txt.NumericValueInteger <> value Then
                SetError("The " + txt.Name + "value has been limited to: " + txt.NumericValueInteger.ToString)
            End If
        Else
            SetError("Option not enabled: " + txt.Name)
        End If
    End Sub

    Private Sub SetNumericValueFloat(ByVal txt As MyTextBox, ByVal value As Double)
        If txt.Enabled And txt.Visible Then
            txt.NumericValue = value
            If txt.NumericValue <> value Then
                SetError("The " + txt.Name + "value has been limited to: " + txt.NumericValue.ToString)
            End If
        Else
            SetError("Option not enabled: " + txt.Name)
        End If
    End Sub

    Private Sub SetComboByText(ByVal cmb As ComboBox, ByVal txt As String)
        For i As Int32 = 0 To cmb.Items.Count - 1
            If CompareLettersAndDigits(cmb.Items(i).ToString, txt) Then
                txt = cmb.Items(i).ToString
                cmb.SelectedIndex = i
                cmb.Refresh()
                Return
            End If
        Next
        SetError("Command not valid: " + TextCommand)
    End Sub

    Friend Function CompareLettersAndDigits(ByVal s1 As String, ByVal s2 As String) As Boolean
        s1 = LettersOrDigitsOnly(s1).ToLower
        s2 = LettersOrDigitsOnly(s2).ToLower
        Return s1 = s2
    End Function

    Friend Function LettersOrDigitsOnly(ByVal str As String) As String
        Dim result As String = ""
        For Each c As Char In str
            If Char.IsLetterOrDigit(c) Then
                result += c
            End If
        Next
        Return result
    End Function

End Module
